JUCE: RectangleList< ValueType > Class Template Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
RectangleList< ValueType > Class Template Referencefinal
juce_graphics » geometry

Maintains a set of rectangles as a complex region. More...

`#include <juce_RectangleList.h>`

## Public Types
using | RectangleType = Rectangle< ValueType >

## Public Member Functions
| RectangleList ()=default
| Creates an empty RectangleList.
| RectangleList (const RectangleList &other)
| Creates a copy of another list.
| RectangleList (RectangleType rect)
| Creates a list containing just one rectangle.
RectangleList & | operator= (const RectangleList &other)
| Copies this list from another one.
| RectangleList (RectangleList &&other) noexcept
| Move constructor.
RectangleList & | operator= (RectangleList &&other) noexcept
| Move assignment operator.
bool | isEmpty () const noexcept
| Returns true if the region is empty.
int | getNumRectangles () const noexcept
| Returns the number of rectangles in the list.
RectangleType | getRectangle (int index) const noexcept
| Returns one of the rectangles at a particular index.
void | clear ()
| Removes all rectangles to leave an empty region.
void | add (RectangleType rect)
| Merges a new rectangle into the list.
void | add (ValueType x, ValueType y, ValueType width, ValueType height)
| Merges a new rectangle into the list.
void | addWithoutMerging (RectangleType rect)
| Dumbly adds a rectangle to the list without checking for overlaps.
void | add (const RectangleList &other)
| Merges another rectangle list into this one.
void | subtract (const RectangleType rect)
| Removes a rectangular region from the list.
bool | subtract (const RectangleList &otherList)
| Removes all areas in another RectangleList from this one.
bool | clipTo (RectangleType rect)
| Removes any areas of the region that lie outside a given rectangle.
template<typename OtherValueType >
bool | clipTo (const RectangleList< OtherValueType > &other)
| Removes any areas of the region that lie outside a given rectangle list.
bool | getIntersectionWith (RectangleType rect, RectangleList &destRegion) const
| Creates a region which is the result of clipping this one to a given rectangle.
void | swapWith (RectangleList &otherList) noexcept
| Swaps the contents of this and another list.
bool | containsPoint (Point< ValueType > point) const noexcept
| Checks whether the region contains a given point.
bool | containsPoint (ValueType x, ValueType y) const noexcept
| Checks whether the region contains a given point.
bool | containsRectangle (RectangleType rectangleToCheck) const
| Checks whether the region contains the whole of a given rectangle.
bool | intersectsRectangle (RectangleType rectangleToCheck) const noexcept
| Checks whether the region contains any part of a given rectangle.
bool | intersects (const RectangleList &other) const noexcept
| Checks whether this region intersects any part of another one.
RectangleType | getBounds () const noexcept
| Returns the smallest rectangle that can enclose the whole of this region.
void | consolidate ()
| Optimises the list into a minimum number of constituent rectangles.
void | offsetAll (Point< ValueType > offset) noexcept
| Adds an x and y value to all the coordinates.
void | offsetAll (ValueType dx, ValueType dy) noexcept
| Adds an x and y value to all the coordinates.
template<typename ScaleType >
void | scaleAll (ScaleType scaleFactor) noexcept
| Scales all the coordinates.
void | transformAll (const AffineTransform &transform) noexcept
| Applies a transform to all the rectangles.
Path | toPath () const
| Creates a Path object to represent this region.
const RectangleType * | begin () const noexcept
| Standard method for iterating the rectangles in the list.
const RectangleType * | end () const noexcept
| Standard method for iterating the rectangles in the list.
void | ensureStorageAllocated (int minNumRectangles)
| Increases the internal storage to hold a minimum number of rectangles.

## Detailed Description

template<typename ValueType>
class RectangleList< ValueType >

Maintains a set of rectangles as a complex region.

This class allows a set of rectangles to be treated as a solid shape, and can add and remove rectangular sections of it, and simplify overlapping or adjacent rectangles.

See also
  Rectangle

## Member Typedef Documentation

## ◆ RectangleType

template<typename ValueType >

using RectangleList< ValueType >::RectangleType = Rectangle<ValueType>

## Constructor & Destructor Documentation

## ◆ RectangleList() [1/4]

template<typename ValueType >

RectangleList< ValueType >::RectangleList | ( |  | ) |
| default

Creates an empty RectangleList.

## ◆ RectangleList() [2/4]

template<typename ValueType >

RectangleList< ValueType >::RectangleList | ( | const RectangleList< ValueType > & | other | ) |

Creates a copy of another list.

## ◆ RectangleList() [3/4]

template<typename ValueType >

RectangleList< ValueType >::RectangleList | ( | RectangleType | rect | ) |

Creates a list containing just one rectangle.

References RectangleList< ValueType >::addWithoutMerging().

## ◆ RectangleList() [4/4]

template<typename ValueType >

RectangleList< ValueType >::RectangleList | ( | RectangleList< ValueType > && | other | ) |
| noexcept

Move constructor.

## Member Function Documentation

## ◆ operator=() [1/2]

template<typename ValueType >

RectangleList & RectangleList< ValueType >::operator= | ( | const RectangleList< ValueType > & | other | ) |

Copies this list from another one.

## ◆ operator=() [2/2]

template<typename ValueType >

RectangleList & RectangleList< ValueType >::operator= | ( | RectangleList< ValueType > && | other | ) |
| noexcept

Move assignment operator.

## ◆ isEmpty()

template<typename ValueType >

bool RectangleList< ValueType >::isEmpty | ( |  | ) | const
| noexcept

Returns true if the region is empty.

Referenced by RectangleList< ValueType >::add(), RectangleList< ValueType >::clipTo(), RectangleList< ValueType >::containsRectangle(), RectangleList< ValueType >::getBounds(), RectangleList< ValueType >::getIntersectionWith(), and RectangleList< ValueType >::subtract().

## ◆ getNumRectangles()

template<typename ValueType >

int RectangleList< ValueType >::getNumRectangles | ( |  | ) | const
| noexcept

Returns the number of rectangles in the list.

## ◆ getRectangle()

template<typename ValueType >

RectangleType RectangleList< ValueType >::getRectangle | ( | int | index | ) | const
| noexcept

Returns one of the rectangles at a particular index.

Returns
  the rectangle at the index, or an empty rectangle if the index is out-of-range.

## ◆ clear()

template<typename ValueType >

void RectangleList< ValueType >::clear | ( |  | ) |

Removes all rectangles to leave an empty region.

Referenced by RectangleList< ValueType >::clipTo(), and RectangleList< ValueType >::getIntersectionWith().

## ◆ add() [1/3]

template<typename ValueType >

void RectangleList< ValueType >::add | ( | RectangleType | rect | ) |

Merges a new rectangle into the list.

The rectangle being added will first be clipped to remove any parts of it that overlap existing rectangles in the list, and adjacent rectangles will be merged into it.

The rectangle can have any size and may be empty, but if it's floating point then it's expected to not contain any INF values.

References Rectangle< ValueType >::contains(), Rectangle< ValueType >::intersects(), Rectangle< ValueType >::isEmpty(), RectangleList< ValueType >::isEmpty(), Rectangle< ValueType >::isFinite(), jassert, and RectangleList< ValueType >::subtract().

Referenced by RectangleList< ValueType >::add(), and RectangleList< ValueType >::add().

## ◆ add() [2/3]

template<typename ValueType >

void RectangleList< ValueType >::add | ( | ValueType | x,
|  | ValueType | y,
|  | ValueType | width,
|  | ValueType | height
| ) |  |

Merges a new rectangle into the list.

The rectangle being added will first be clipped to remove any parts of it that overlap existing rectangles in the list.

References RectangleList< ValueType >::add(), x, and y.

## ◆ addWithoutMerging()

template<typename ValueType >

void RectangleList< ValueType >::addWithoutMerging | ( | RectangleType | rect | ) |

Dumbly adds a rectangle to the list without checking for overlaps.

This simply adds the rectangle to the end, it doesn't merge it or remove any overlapping bits.

The rectangle can have any size and may be empty, but if it's floating point then it's expected to not contain any INF values.

References Rectangle< ValueType >::isEmpty(), Rectangle< ValueType >::isFinite(), and jassert.

Referenced by RectangleList< ValueType >::RectangleList().

## ◆ add() [3/3]

template<typename ValueType >

void RectangleList< ValueType >::add | ( | const RectangleList< ValueType > & | other | ) |

Merges another rectangle list into this one.

Any overlaps between the two lists will be clipped, so that the result is the union of both lists.

References RectangleList< ValueType >::add().

## ◆ subtract() [1/2]

template<typename ValueType >

void RectangleList< ValueType >::subtract | ( | const RectangleType | rect | ) |

Removes a rectangular region from the list.

Any rectangles in the list which overlap this will be clipped and subdivided if necessary.

References Rectangle< ValueType >::getHeight(), Rectangle< ValueType >::getWidth(), Rectangle< ValueType >::getX(), Rectangle< ValueType >::getY(), and ignoreUnused().

Referenced by RectangleList< ValueType >::add(), RectangleList< ValueType >::containsRectangle(), and RectangleList< ValueType >::subtract().

## ◆ subtract() [2/2]

template<typename ValueType >

bool RectangleList< ValueType >::subtract | ( | const RectangleList< ValueType > & | otherList | ) |

Removes all areas in another RectangleList from this one.

Any rectangles in the list which overlap this will be clipped and subdivided if necessary.

Returns
  true if the resulting list is non-empty.

References RectangleList< ValueType >::isEmpty(), and RectangleList< ValueType >::subtract().

## ◆ clipTo() [1/2]

template<typename ValueType >

bool RectangleList< ValueType >::clipTo | ( | RectangleType | rect | ) |

Removes any areas of the region that lie outside a given rectangle.

Any rectangles in the list which overlap this will be clipped and subdivided if necessary.

Returns true if the resulting region is not empty, false if it is empty.

See also
  getIntersectionWith

References RectangleList< ValueType >::clear(), Rectangle< ValueType >::intersectRectangle(), Rectangle< ValueType >::isEmpty(), Rectangle< ValueType >::isFinite(), and jassert.

## ◆ clipTo() [2/2]

template<typename ValueType >
template<typename OtherValueType >

bool RectangleList< ValueType >::clipTo | ( | const RectangleList< OtherValueType > & | other | ) |

Removes any areas of the region that lie outside a given rectangle list.

Any rectangles in this object which overlap the specified list will be clipped and subdivided if necessary.

Returns true if the resulting region is not empty, false if it is empty.

See also
  getIntersectionWith

References RectangleList< ValueType >::isEmpty(), and RectangleList< ValueType >::swapWith().

## ◆ getIntersectionWith()

template<typename ValueType >

bool RectangleList< ValueType >::getIntersectionWith | ( | RectangleType | rect,
|  | RectangleList< ValueType > & | destRegion
| ) |  | const

Creates a region which is the result of clipping this one to a given rectangle.

Unlike the other clipTo method, this one doesn't affect this object - it puts the resulting region into the list whose reference is passed-in.

Returns true if the resulting region is not empty, false if it is empty.

See also
  clipTo

References RectangleList< ValueType >::clear(), Rectangle< ValueType >::intersectRectangle(), Rectangle< ValueType >::isEmpty(), RectangleList< ValueType >::isEmpty(), Rectangle< ValueType >::isFinite(), and jassert.

## ◆ swapWith()

template<typename ValueType >

void RectangleList< ValueType >::swapWith | ( | RectangleList< ValueType > & | otherList | ) |
| noexcept

Swaps the contents of this and another list.

This swaps their internal pointers, so is hugely faster than using copy-by-value to swap them.

Referenced by RectangleList< ValueType >::clipTo().

## ◆ containsPoint() [1/2]

template<typename ValueType >

bool RectangleList< ValueType >::containsPoint | ( | Point< ValueType > | point | ) | const
| noexcept

Checks whether the region contains a given point.

Returns
  true if the point lies within one of the rectangles in the list

Referenced by RectangleList< ValueType >::containsPoint().

## ◆ containsPoint() [2/2]

template<typename ValueType >

bool RectangleList< ValueType >::containsPoint | ( | ValueType | x,
|  | ValueType | y
| ) |  | const
| noexcept

Checks whether the region contains a given point.

Returns
  true if the point lies within one of the rectangles in the list

References RectangleList< ValueType >::containsPoint(), x, and y.

## ◆ containsRectangle()

template<typename ValueType >

bool RectangleList< ValueType >::containsRectangle | ( | RectangleType | rectangleToCheck | ) | const

Checks whether the region contains the whole of a given rectangle.

Returns
  true all parts of the rectangle passed in lie within the region defined by this object

See also
  intersectsRectangle, containsPoint

References RectangleList< ValueType >::isEmpty(), and RectangleList< ValueType >::subtract().

## ◆ intersectsRectangle()

template<typename ValueType >

bool RectangleList< ValueType >::intersectsRectangle | ( | RectangleType | rectangleToCheck | ) | const
| noexcept

Checks whether the region contains any part of a given rectangle.

Returns
  true if any part of the rectangle passed in lies within the region defined by this object

See also
  containsRectangle

## ◆ intersects()

template<typename ValueType >

bool RectangleList< ValueType >::intersects | ( | const RectangleList< ValueType > & | other | ) | const
| noexcept

Checks whether this region intersects any part of another one.

See also
  intersectsRectangle

## ◆ getBounds()

template<typename ValueType >

RectangleType RectangleList< ValueType >::getBounds | ( |  | ) | const
| noexcept

Returns the smallest rectangle that can enclose the whole of this region.

References RectangleList< ValueType >::isEmpty(), jmax(), and jmin().

## ◆ consolidate()

template<typename ValueType >

void RectangleList< ValueType >::consolidate | ( |  | ) |

Optimises the list into a minimum number of constituent rectangles.

This will try to combine any adjacent rectangles into larger ones where possible, to simplify lists that might have been fragmented by repeated add/subtract calls.

## ◆ offsetAll() [1/2]

template<typename ValueType >

void RectangleList< ValueType >::offsetAll | ( | Point< ValueType > | offset | ) |
| noexcept

Adds an x and y value to all the coordinates.

Referenced by RectangleList< ValueType >::offsetAll().

## ◆ offsetAll() [2/2]

template<typename ValueType >

void RectangleList< ValueType >::offsetAll | ( | ValueType | dx,
|  | ValueType | dy
| ) |  |
| noexcept

Adds an x and y value to all the coordinates.

References RectangleList< ValueType >::offsetAll().

## ◆ scaleAll()

template<typename ValueType >
template<typename ScaleType >

void RectangleList< ValueType >::scaleAll | ( | ScaleType | scaleFactor | ) |
| noexcept

Scales all the coordinates.

## ◆ transformAll()

template<typename ValueType >

void RectangleList< ValueType >::transformAll | ( | const AffineTransform & | transform | ) |
| noexcept

Applies a transform to all the rectangles.

Obviously this will create a mess if the transform involves any rotation or skewing.

## ◆ toPath()

template<typename ValueType >

Path RectangleList< ValueType >::toPath | ( |  | ) | const

Creates a Path object to represent this region.

References Path::addRectangle().

## ◆ begin()

template<typename ValueType >

const RectangleType * RectangleList< ValueType >::begin | ( |  | ) | const
| noexcept

Standard method for iterating the rectangles in the list.

## ◆ end()

template<typename ValueType >

const RectangleType * RectangleList< ValueType >::end | ( |  | ) | const
| noexcept

Standard method for iterating the rectangles in the list.

## ◆ ensureStorageAllocated()

template<typename ValueType >

void RectangleList< ValueType >::ensureStorageAllocated | ( | int | minNumRectangles | ) |

Increases the internal storage to hold a minimum number of rectangles.

Calling this before adding a large number of rectangles means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

See also
  Array::ensureStorageAllocated

The documentation for this class was generated from the following file:

- juce_RectangleList.h